package org.oasis.wscaf.middleware.wsctx.manager;

import org.apache.axiom.om.OMElement;
import org.apache.axis2.AxisFault;
import org.apache.axis2.context.MessageContext;
import org.oasis.wscaf.core.wsctx.exceptions.InvalidContext;
import org.oasis.wscaf.core.wsctx.exceptions.NoContext;
import org.oasis.wscaf.utils.Constants;
import org.oasis.wscaf.utils.ContextUtils;
import org.oasis.wscaf.utils.exceptions.ElementNotFound;

public class ContextManagerMessageReceiverInOutHelper extends
		ContextManagerMessageReceiverInOut {

	public void invokeBusinessLogic(MessageContext msgContext, MessageContext newMsgContext) throws AxisFault {
		
		OMElement context = null;
		try {
			context = ContextUtils.getContext(msgContext,Constants.CONTEXT_NAME);
		} catch (ElementNotFound e1) {
			e1.printStackTrace();
			if (e1.getMissingElement().equals(Constants.CONTEXT_NAME)) {
				throw new NoContext("Required context "+Constants.CONTEXT_NAME+" was not found in header",e1);
			}
			else {
				throw new InvalidContext("Context is not valid. Missing or malformed required element "+e1.getMissingElement());
			}
		}
		
		msgContext.setProperty(Constants.CurrentContextProperty, context);

		super.invokeBusinessLogic(msgContext, newMsgContext);
	
		newMsgContext.getEnvelope().getHeader().addChild(context);
			
	}
	
	

}
