package org.oasis.wscaf.middleware.wsctx.service;

import org.apache.axiom.om.OMElement;
import org.apache.axis2.AxisFault;
import org.apache.axis2.context.MessageContext;
import org.apache.axis2.description.AxisOperation;
import org.oasis.wscaf.core.wsctx.exceptions.InvalidContext;
import org.oasis.wscaf.core.wsctx.exceptions.NoContext;
import org.oasis.wscaf.utils.Constants;
import org.oasis.wscaf.utils.ContextUtils;
import org.oasis.wscaf.utils.exceptions.ElementNotFound;

public class ContextServiceMessageReceiverInOutHelper extends
		ContextServiceMessageReceiverInOut {

	public void invokeBusinessLogic(MessageContext msgContext, MessageContext newMsgContext) throws AxisFault {

		OMElement context = null;
		try {
			context = ContextUtils.getContext(msgContext,Constants.CONTEXT_NAME);
		} catch (ElementNotFound e1) {
			AxisOperation op = msgContext.getAxisOperation();
			java.lang.String methodName = org.apache.axis2.util.JavaUtils.xmlNameToJava(op.getName().getLocalPart());
	        
			if (!methodName.equals("begin")) {
				e1.printStackTrace();
				if (e1.getMissingElement().equals(Constants.CONTEXT_NAME)) {
					throw new NoContext("Required context "+Constants.CONTEXT_NAME+" was not found in header",e1);
				}
				else {
					throw new InvalidContext("Context is not valid. Missing or malformed required element "+e1.getMissingElement());
				}
			}
		}
		
		msgContext.setProperty(Constants.CurrentContextProperty, context);
		
		super.invokeBusinessLogic(msgContext, newMsgContext);
		
		Object ctx = msgContext.getProperty(Constants.NewContextProperty);
		
		if (ctx != null) {
			context = (OMElement)ctx;
		}
		
		if (context != null) {
			newMsgContext.getEnvelope().getHeader().addChild(context);
		}
	}
	
	

}
