package org.oasis.wscaf.newcore.types.wsctx;

import java.net.URI;
import java.util.ArrayList;
import java.util.Set;

import javax.xml.namespace.QName;

import org.apache.axiom.om.OMElement;
import org.apache.axis2.addressing.EndpointReference;
import org.oasis.wscaf.newcore.types.common.Element;
import org.oasis.wscaf.newcore.types.common.Namespaces;

public interface Context extends Element{
	
	public static final QName NAME = new QName(Namespaces.WSCTX_NAMESPACE,"context");
	public static final QName CONTEXT_IDENTIFIER_NAME = new QName(Namespaces.WSCTX_NAMESPACE,"context-identifier");
	public static final QName CONTEXT_SERVICE_NAME = new QName(Namespaces.WSCTX_NAMESPACE,"context-service");
	public static final QName CONTEXT_MANAGER_NAME = new QName(Namespaces.WSCTX_NAMESPACE,"context-manager");
	public static final QName PARENT_CONTEXT_NAME = new QName(Namespaces.WSCTX_NAMESPACE,"parent-context");
	
	public URI getIdentifier();
	public void setIdentifier(URI identifier);
	
	public EndpointReference getContextManager();
	public void setContextManager(EndpointReference manager);
	
	public EndpointReference getContextService();
	public void setContextService(EndpointReference service);
	
	public Context getParentContext();
	public void setParentContext(Context parentContext);
	
	public ArrayList getAugmenter(QName name);
	public void addAugmenter(OMElement augmenter);
	public void removeAugmenter(QName augmenter);
	
	public Set getAugmenters();
	
}
