/**
  * JASS Project. WS-CAF.
  *
  * Copyright (c) 2006, Distributed Systems Lab, Universidad Politecnica 
  * de Madrid (Spain)
  * All rights reserved.
  * Contact:
  *        web page: http://lsd.ls.fi.upm.es/lsd
  *        e-mail: mpatino@fi.upm.es or rjimenez@fi.upm.es
  *
  * Redistribution and use in source and binary forms, with or without 
  * modification, are permitted provided that the following conditions are met:
  *
  *    - Redistributions of source code must retain the above copyright 
  *      notice, this list of conditions and the following disclaimer.
  *    - Redistributions in binary form must reproduce the above copyright 
  *      notice, this list of conditions and the following disclaimer in the 
  *      documentation and/or other materials provided with the distribution.
  *    - Neither the name of the Distributed Systems Lab nor the names of 
  *      its contributors may be used to endorse or promote products derived from 
  *      this software without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
  * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
  * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
  * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
  * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
  * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, *
  * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
  * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
  * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  * 
  * Contributors: 
  * Francisco Pérez-Sorrosal (fpsorrosal@zipi.fi.upm.es)
  * Rubén Naranjo Izquierdo (rnaranjo@alumnos.upm.es)
  * José Antonio Sánchez Murillo (jsanchez@alumnos.upm.es)
  * 
  **/

package org.oasis.wscaf.utils;

import javax.xml.namespace.QName;

import org.apache.axis2.addressing.AddressingConstants;

public abstract class Constants {

    public static String CONTEXT_NS      = "http://docs.oasis-open.org/ws-caf/2005/10/wsctx";
    public static String COORDINATION_NS = "http://docs.oasis-open.org/wscaf/2005/10/wscf";
    public static String LRA_NS          = "http://www.webservicestransactions.org/schemas/wstxm/tx-lra/2003/03";
                                           
    //public static String ADDRESSING_NS   = "http://schemas.xmlsoap.org/ws/2004/08/addressing";
    //public static String ADDRESSING_NS   = AddressingConstants.Final.WSA_NAMESPACE;
    public static String SOAP_NS         = "http://schemas.xmlsoap.org/wsdl/soap/";
    
    public static String CurrentContextProperty = CONTEXT_NS+"/currentContext";
    public static String CurrentContextIdentifier = CONTEXT_NS+"/currentContextIdentifier";
    public static String NewContextProperty = CONTEXT_NS+"/newContext";

    //public static String CONTEXT_SERVICE_EPR      = "http://localhost:8080/axis2/services/WSCAF-ContextService";
    //public static String REGISTRATION_SERVICE_EPR = "http://localhost:8080/axis2/services/WSCAF-RegistrationService";
    //public static String COORDINATOR_SERVICE_EPR  = "http://localhost:8080/axis2/services/WSCAF-CoordinatorService";

    //public static String EPR_NAME      = "EndpointReference";
    //public static String ADDRESS_NAME  = "Address";
    //public static String PORTTYPE_NAME = "PortType";

    public static String COMPLETE_STATUS_NAME = "status";
    public static String SUCCESS_NAME         = "SUCCESS";
    public static String FAIL_NAME            = "FAIL";
    public static String FORGET_NAME          = "FOGET";
    
    public static String EXTENSION_NS = "http://lsd.org/ws-caf";
    public static QName PARTICIPANT_NUMBER_NAME = new QName(EXTENSION_NS,"participant-number");
    public static QName COORDINATOR_SERVICE = new QName(EXTENSION_NS,"coordinator-service");
    
    public static QName CONTEXT_NAME = new QName(CONTEXT_NS,"context");
    public static QName CONTEXT_MANAGER_NAME = new QName(CONTEXT_NS,"context-manager");
    public static QName CONTEXT_SERVICE_NAME = new QName(CONTEXT_NS,"context-service");
    public static QName CONTEXT_IDENTIFIER_NAME = new QName(CONTEXT_NS,"context-identifier");
    public static QName PARENT_CONTEXT_NAME = new QName(CONTEXT_NS,"parent-context");
    
    public static QName REGISTRATION_CONTEXT_NAME = new QName(COORDINATION_NS,"registrationContext");
    public static QName REGISTRATION_SERVICE_NAME = new QName(COORDINATION_NS,"registration-service");
    public static QName SUB_PROTOCOL_NAME = new QName(COORDINATION_NS,"sub-protocol");
    public static QName PARTICIPANTS_NAME = new QName(COORDINATION_NS,"participants");
    public static QName EXTENSION_NAME = new QName(COORDINATION_NS,"extension");
    
    public static QName LRA_CONTEXT_NAME = new QName(LRA_NS,"lraContext");
    
    public static QName GENERIC_XBEAN_ELEMENT = new QName("xml-fragment");
    public static QName ENDPOINTREFERENCE_FINAL_NAME = new QName(AddressingConstants.Final.WSA_NAMESPACE,"EndpointReference","wsa");
    
	public static String DEFAULT_CONTEXT_TYPE = "http://org.objectweb.wscaf.wsctx/contextType";
	
	
	public static QName STATE_TIMED_OUT = new QName(CONTEXT_NS,"activity.status.wsctx.TimedOut");
	public static QName STATE_COMPLETED = new QName(CONTEXT_NS,"activity.status.wsctx.Completed");
	public static QName STATE_RUNNING   = new QName(CONTEXT_NS,"activity.status.wsctx.Running");
	
	public static QName STATE_LRA_COMPENSATING       = new QName(LRA_NS,"activity.status.tx-lra.Compensating");
	public static QName STATE_LRA_COMPENSATED        = new QName(LRA_NS,"activity.status.tx-lra.Compensated");
	public static QName STATE_LRA_FAILED_TO_COMPENSATE = new QName(LRA_NS,"activity.status.tx-lra.FailedToCompensate");
	public static QName STATE_LRA_COMPLETING         = new QName(LRA_NS,"activity.status.tx-lra.Completing");
	public static QName STATE_LRA_COMPLETED          = new QName(LRA_NS,"activity.status.tx-lra.Completed");
	public static QName STATE_LRA_FAILED_TO_COMPLETE = new QName(LRA_NS,"activity.status.tx-lra.FailedToComplete");
    

}
